package labss.lang.il.model;

public interface ILAbstractFactory {
//TODO esercizio: posso ritornare dei tipi astratti che per espongano le API specifiche?
//TODO esercizio: posso ritornare dei tipi concreti?
    public Statement createWhile(Expression exp, Statement stm);
//TODO esercizio: posso implementarlo appoggiandomi all'implementazione completa dell'If?
    public Statement createIf(Expression exp, Statement thenStm);
    public Statement createIf(Expression exp, Statement thenStm, Statement elseStm);
    public Statement createEmpty();
//TODO esercizio: considerare alternative per il tipo di var: Expression, Variable
    public Statement createAssignment(String var, Expression exp);
    public Statement createBlock(Statement... stms);
//TODO esercizio: posso sfruttare il fatto che i booleani hanno solo due valori?
    public Literal createBoolean(boolean val);
    public Literal createInt(int val);
    public Expression createVariable(String name);
    public Expression createAddition(Expression exp1, Expression exp2);
    public Expression createSubtraction(Expression exp1, Expression exp2);
    public Expression createMultiplication(Expression exp1, Expression exp2);
    public Expression createDivision(Expression exp1, Expression exp2);
    public Expression createAnd(Expression exp1, Expression exp2);
    public Expression createOr(Expression exp1, Expression exp2);
    public Expression createNot(Expression exp);
    public Expression createEquals(Expression exp1, Expression exp2);
    public Expression createLessThan(Expression exp1, Expression exp2);
    public Expression createGreaterThan(Expression exp1, Expression exp2);
    
//TODO esercizio: quanto costa aggiungerlo?
//TODO esercizio: posso implementarlo come composizione di altri prodotti?
    public Expression createGreaterOrEquals(Expression exp1, Expression exp2);    
}
