package labss.lang.il.model.impl;

import labss.lang.il.model.Expression;
import labss.lang.il.model.Statement;


public class Assignment implements Statement {
	protected Assignment(Variable variable, Expression expression) {
		this.variable = variable;
		this.expression = expression;
	}

	/**
	 * @uml.property  name="variable"
	 * @uml.associationEnd  aggregation="composite" inverse="assignment:labss.lang.il.model.Variable"
	 */
	private Variable variable;

	/**
	 * Getter of the property <tt>variable</tt>
	 * @return  Returns the variable.
	 * @uml.property  name="variable"
	 */
	public Variable getVariable() {
		return variable;
	}

	/**
	 * Setter of the property <tt>variable</tt>
	 * @param variable  The variable to set.
	 * @uml.property  name="variable"
	 */
	public void setVariable(Variable variable) {
		this.variable = variable;
	}

	/**
	 * @uml.property  name="expression"
	 * @uml.associationEnd  aggregation="composite" inverse="assignment:labss.lang.il.model.Expression"
	 */
	private Expression expression;

	/**
	 * Getter of the property <tt>expression</tt>
	 * @return  Returns the expression.
	 * @uml.property  name="expression"
	 */
	public Expression getExpression() {
		return expression;
	}

	/**
	 * Setter of the property <tt>expression</tt>
	 * @param expression  The expression to set.
	 * @uml.property  name="expression"
	 */
	public void setExpression(Expression expression) {
		this.expression = expression;
	}

}
