package labss.lang.il.model.impl;

import labss.lang.il.model.Literal;


public class Bool implements Literal {
	// Singleton
	public static final Bool TRUE = new Bool(true);
	public static final Bool FALSE = new Bool(false);
	public static final Bool instance(boolean value) {
		return value ? TRUE: FALSE;
	}
	private Bool(boolean val) {
		this.value = val;
	}


	/**
	 * @uml.property  name="value"
	 */
	private boolean value;

	/**
	 * Getter of the property <tt>value</tt>
	 * @return  Returns the value.
	 * @uml.property  name="value"
	 */
	public boolean getValue() {
		return value;
	}

	/**
	 * Setter of the property <tt>value</tt>
	 * @param value  The value to set.
	 * @uml.property  name="value"
	 */
	public void setValue(boolean value) {
		this.value = value;
	}

}
