package labss.il.lab;

import labss.lang.il.model.Expression;
import labss.lang.il.model.Literal;
import labss.lang.il.model.Statement;

public interface LabIlAbstractFactory {
	Expression createVar(String string);
	Literal createInt(int i);
	Statement createAssign(Expression createVar, Expression createInt);
	Statement createBlock(Statement... stms);

// prodotto "while" configurabile solo al momento della costruzione
	Statement createWhile(Expression cond, Statement body);

// prodotto "while" configurabile sono dopo la costruzione
	IWhile createWhile();
}
