package labss.lang.il;

import static labss.lang.il.model.impl.ILStaticFactory.*;
import labss.lang.il.model.ILAbstractFactory;
import labss.lang.il.model.Statement;
import labss.lang.il.model.impl.ILConcreteFactory;

public class ProgrammaFattoriale {
	public static void eseguiProgrammaFattorialeInJava() {
		int n, result;
		{
			n = 4;
			result = 1;
			while (n > 0) {
				result = result * n;
				n = n -1;
			}
		}
	}
//TODO esercizio: rendere obbligatorio l'uso di una factory
//	public static Statement creaProgrammaFattorialeInIL() {
//		return new Block(
//				new Assignment(new Variable("n"), new Int(4)),
//				new Assignment(new Variable("result"), new Int(1)),
//				new While(new GreaterThan(new Variable("n"), new Int(0)), new Block(
//						new Assignment(new Variable("result"),
//								new Multiplication(new Variable("result"), new Variable("n"))),
//						new Assignment(new Variable("n"),
//								new Subtraction(new Variable("n"), new Int(1)))
//				)));
//	}
	public static Statement creaProgrammaFattorialeInILConFactory(ILAbstractFactory f) {
		return f.createBlock(
				f.createAssignment("n", f.createInt(4)),
				f.createAssignment("result", f.createInt(1)),
				f.createWhile(f.createGreaterThan(f.createVariable("n"), f.createInt(0)), f.createBlock(
						f.createAssignment("result",
								f.createMultiplication(f.createVariable("result"), f.createVariable("n"))),
						f.createAssignment("n",
								f.createSubtraction(f.createVariable("n"), f.createInt(1)))
				)));
	}
	public static Statement creaProgrammaFattorialeInILConFactoryStatica() {
		return createBlock(
				createAssignment("n", createInt(4)),
				createAssignment("result", createInt(1)),
				createWhile(createGreaterThan(createVariable("n"), createInt(0)), createBlock(
						createAssignment("result",
								createMultiplication(createVariable("result"), createVariable("n"))),
						createAssignment("n",
								createSubtraction(createVariable("n"), createInt(1)))
				)));
	}
	
	public static void main(String[] args) {
		eseguiProgrammaFattorialeInJava();
//		interpreta(creaProgrammaFattorialeInIL());
		interpreta(creaProgrammaFattorialeInILConFactory(ILConcreteFactory.instance()));
		interpreta(creaProgrammaFattorialeInILConFactoryStatica());
	}

	public static void interpreta(Statement programma) {
		//TODO
	}
}
